//
//  Shader.vsh
//  BrideZilla
//
//  Created by Benzo on 5/11/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

varying vec2 texCoord;
varying vec4 colorVarying;
varying vec4 texColor;

attribute vec4 vertex;
attribute vec4 color;
attribute vec2 texCoord0;



uniform vec4 translate;
uniform vec4 scale;

uniform float rotate;

//uniform mat4 gl_ModelViewMatrix;
//uniform mat4 gl_ProjectionMatrix;



uniform vec2 screenSize;
// aka width of 1 pixel in opengl coordinates
uniform vec2 halfScreenSizeInv; // = 0.5/screenSize.x, 0.5/screenSize.y

uniform float globalRotate;



void main()
{
	vec4 pos;
	vec4 tmp;
	
	pos = vertex;

	tmp = pos;
	
	pos.x = tmp.x*cos(rotate) - tmp.y*sin(rotate);
	pos.y = tmp.x*sin(rotate) + tmp.y*cos(rotate); 

	pos.xy *= scale.xy;
	pos += translate;
	tmp.xy += halfScreenSizeInv.xy;
	pos.xy = pos.xy*halfScreenSizeInv.xy;

	// TODO: add half a pixel to pos to get pixel center
	pos.x -= 1.0;
	pos.y -= 1.0;

	tmp.x = pos.x*cos(globalRotate) - pos.y*sin(globalRotate);
	tmp.y = pos.x*sin(globalRotate) + pos.y*cos(globalRotate);
	tmp.z = 0.0;
	tmp.w = 1.0;


	gl_Position = tmp;

	
	colorVarying = color;
	
	texCoord =  texCoord0;
}
